-------------
--START TIMER
------------


	--ACE 3 TIMER SECTION
	MyAddonzx = LibStub("AceAddon-3.0"):NewAddon("TimerTestzx", "AceTimer-3.0")

	function MyAddonzx:OnEnable()
	  self.timerCount = 0
 	 self.testTimer = self:ScheduleRepeatingTimer("TimerFeedback", 0.11)
	end



------------------------
-- VARIABLES Section
------------------------

local empty = "Interface\\AddOns\\retrot\\txt\\basic\\empty.tga"
local hpone = "Interface\\AddOns\\retrot\\txt\\basic\\hpone.tga"
local hptwo = "Interface\\AddOns\\retrot\\txt\\basic\\hptwo.tga"
local hpthree = "Interface\\AddOns\\retrot\\txt\\basic\\pthree.tga"

rr_AoW = GetSpellInfo(59578)  --art or war
rr_HoW = GetSpellInfo(48806)  --Hammer of wrath  
rr_inq = GetSpellInfo(84963)  --inquisition
rr_zel = GetSpellInfo(85696)  --zealotry
rr_spellnameCS = GetSpellInfo(35395) --Crusader Strike
rr_spellnameJ = GetSpellInfo(20271)  --Judtgement
rr_spellnameEXO = GetSpellInfo(879) --Exorcism
rr_spellnameHW = GetSpellInfo(2812) --Holy Wrath
rr_spellnameHOW = GetSpellInfo(24275) --Hammer of wrath
rr_spellnameTV = GetSpellInfo(85256)	--Templars Verdict
rr_spellnameHOL = GetSpellInfo(90174)	--hand of light
rr_spellnameAW = GetSpellInfo(31884)	--Avenging Wrath
rr_spellnameDS = GetSpellInfo(53385)	--Divine Storm


--Spell usable variables
how_usable = 0   -- hammer of wrath   1 (true) if the spell is usable nil otherwise.
rr_mana = 0
aow_usable = 0  --art of war usable   1 (true) if the spell is usable  nil otherwise.
gcd = 0 		--GCD
fullgcd = 1.5	--Holds the FULL GCD length, after haste is applied.
inqtime = 0 	--Time left on inquisition
AB1name = "" 	--ability names
AB2name = ""
lastAB1 = ""	--What ability was used in this slot last
lastAB2 = ""	--What ability was used in this slot last
holypow = 0	--Holy Power
abdelta = 0.0 	--offset on calcualating in lag
hol_proc = 0 	--Hand of Light Ret Proc 
wcataclysm = 1	-- 1=testing on cataclysm   0=testing on live
rrh_version = "Retribution Rotation Helper Version 4.01-b4"
playerlevel = 0 --Player Level
playerclass = "" --player class
rr_awcd = 0	--Avenging Wrath CD
rr_zelcd = 0	--Zealotry CD
rr_isRetSpec = 0 --Variable to store if player is specced ret or not.
rr_multi = 0  --Using multi target rotation?


------------------------
-- SAVED VARIABLES Section
------------------------
rr_scale = 1        --Frame scaling
rr_inqclip = 0      --Inquisition Clipping in seconds, 0 = disabled
rr_jmana = 0        --Priotitize Judgement if JoTW not active 1=yes 0=no
rr_dp = 1           --Divine Plea at threshold.
rr_dpthresh = 25    --Divine Plea threshold as a percentage of total mana
rr_conc = 0         --Include Consecration in rotation
rr_concthresh = 75  --Cosecrate if above this percent mana
rr_wepspd = 3.6		--Unhasted Weapon speed, used for calculating GCD haste
rr_x=  333			--X position of display frame
rr_y=	 333			--Y positopn of display frame
rr_cs_gcd_delay =0 	--Delay on GCD for CS to come off CD
rr_inqenabled = 1	--Inquisition enabled in rotation?
rr_rmenabled = 1	--Is the rotation manager enabled?
rr_crenabled = 0 	--Custom rotation enabled?
rr_cab1 = "CS"		--Custom Rotation order Variables
rr_cab2 = "EXO"		--Custom Rotation order Variables
rr_cab3 = "HOW"		--Custom Rotation order Variables
rr_cab4 = "J"		--Custom Rotation order Variables
rr_cab5 = "HW"		--Custom Rotation order Variables
rr_hptexture = 1	--Save holy power indicator preferance 0=links 1=basic
rr_monitorcd = 1	--Monitor AW and Zelotry
rr_autohide = 1		--Auto hide variable



------------------------
-- FRAMES Section
------------------------

--Only start build frames if class = paladin
--if (UnitClass("player") == "PALADIN") then 

---HOLY POWER FRAME
local HPframe = CreateFrame("Frame",HPframe,UIParent)
HPframe:SetFrameStrata("BACKGROUND")
HPframe:SetWidth(128) -- Set these to whatever height/width is needed 
HPframe:SetHeight(32) -- for your Texture

local HPtexture = HPframe:CreateTexture(nil,"BACKGROUND")
HPtexture:SetTexture(empty)
HPtexture:SetAllPoints(HPframe)
HPframe.texture = HPtexture

HPframe:SetPoint("CENTER",0,0)
HPframe:Show()


--movable frame, HP bars
HPframe:SetMovable(true)
HPframe:EnableMouse(true)
HPframe:SetScript("OnMouseDown", function(self)
  if(IsControlKeyDown())then
	rr_y = HPframe:GetBottom();  --update frame position when moved
	rr_x = HPframe:GetLeft();
   self:StartMoving();
   self.isMoving = true;
  end
end)
HPframe:SetScript("OnMouseUp", function(self)
	rr_y = HPframe:GetBottom();  --update frame position when moved
	rr_x = HPframe:GetLeft();
 	if ( self.isMoving ) then
   		self:StopMovingOrSizing();
  	 	self.isMoving = false;
  	end
end)
HPframe:SetScript("OnHide", function(self)
	rr_y = HPframe:GetBottom(); --update frame position when moved
	rr_x = HPframe:GetLeft();
 	if ( self.isMoving ) then
   		self:StopMovingOrSizing();
  	 	self.isMoving = false;
  	end
end)




---FiRST ABILTY FRAME
local AB1frame = CreateFrame("Frame",AB1frame,UIParent)
AB1frame:SetFrameStrata("BACKGROUND")
AB1frame:SetWidth(64) -- Set these to whatever height/width is needed 
AB1frame:SetHeight(64) -- for your Texture

local AB1texture = AB1frame:CreateTexture(nil,"BACKGROUND")
AB1texture:SetTexture(GetSpellTexture("Sinister Strike"))
AB1texture:SetAllPoints(AB1frame)
AB1frame.texture = AB1texture

AB1frame:SetPoint("BOTTOMLEFT", HPframe, "BOTTOMLEFT", 0, -64);
AB1frame:Show()

--Text On buttons
AB1text = AB1frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
AB1text:SetWidth(45)
AB1text:SetJustifyH("CENTER")
AB1text:SetPoint("BOTTOMLEFT", HPframe, "BOTTOMLEFT", 14, -63);



---Second ABILTY FRAME
local AB2frame = CreateFrame("Frame",AB2frame,UIParent)
AB2frame:SetFrameStrata("BACKGROUND")
AB2frame:SetWidth(64) -- Set these to whatever height/width is needed 
AB2frame:SetHeight(64) -- for your Texture

local AB2texture = AB2frame:CreateTexture(nil,"BACKGROUND")
AB2texture:SetTexture(GetSpellTexture("Sinister Strike"))
AB2texture:SetAllPoints(AB2frame)
AB2frame.texture = AB2texture

AB2frame:SetPoint("BOTTOMLEFT", HPframe, "BOTTOMLEFT", 75, -64);
AB2frame:Show()


--Text On buttons
AB2text = AB1frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
AB2text:SetWidth(45)
AB2text:SetJustifyH("CENTER")
AB2text:SetPoint("BOTTOMLEFT", HPframe, "BOTTOMLEFT", 75, -52);




---AW CD Frame
local AWCDframe = CreateFrame("Frame",AWCDframe,UIParent)
AWCDframe:SetFrameStrata("BACKGROUND")
AWCDframe:SetWidth(32) -- Set these to whatever height/width is needed 
AWCDframe:SetHeight(32) -- for your Texture

local AWCDtexture = AWCDframe:CreateTexture(nil,"BACKGROUND")
AWCDtexture:SetTexture(GetSpellTexture(rr_spellnameAW))
AWCDtexture:SetAllPoints(AWCDframe)
AWCDframe.texture = AWCDtexture

AWCDframe:SetPoint("BOTTOMLEFT", HPframe, "BOTTOMLEFT", 131, -32);
AWCDframe:Show()


--Text On buttons
AWCDtext = AWCDframe:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
AWCDtext:SetWidth(45)
AWCDtext:SetJustifyH("CENTER")
AWCDtext:SetPoint("BOTTOMLEFT", HPframe, "BOTTOMLEFT", 125, -24);





---Zealotry CD Frame
local Zelframe = CreateFrame("Frame",Zelframe,UIParent)
Zelframe:SetFrameStrata("BACKGROUND")
Zelframe:SetWidth(32) -- Set these to whatever height/width is needed 
Zelframe:SetHeight(32) -- for your Texture

local Zeltexture = Zelframe:CreateTexture(nil,"BACKGROUND")
Zeltexture:SetTexture(GetSpellTexture("Zealotry"))
Zeltexture:SetAllPoints(Zelframe)
Zelframe.texture = Zeltexture

Zelframe:SetPoint("BOTTOMLEFT", HPframe, "BOTTOMLEFT", 131, -64);
Zelframe:Show()


--Text On buttons
Zeltext = Zelframe:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
Zeltext:SetWidth(45)
Zeltext:SetJustifyH("CENTER")
Zeltext:SetPoint("BOTTOMLEFT", HPframe, "BOTTOMLEFT", 125, -60);





------------------------
-- ADDON FUNCTIONS
------------------------




--parent_Line1:SetText("got here")







-------------------------------------------------
--UPDATE TIMERS/TEXT-----------------------------
--This function runs every timer "tick"----------
-------------------------------------------------
function MyAddonzx:TimerFeedback()


	RRH_updateHolyPowerFrames()  ---- UPDATE HOLY POWER COUNTER AND FRAME	
	
	if (rr_rmenabled == 1) and (rr_crenabled == 0) and (rr_isRetSpec == 1) and (rr_multi == 0) then   --Do rotation manager stuff if rotation manager enabled and default rotation, and you are speced ret
		RRH_updatepowers() 		 --Update cooldowns, spell availability, and GCD
		RRH_rotationanalysis() 	 --Determine Spell order by analysis
		RRH_Update_and_display_AW_and_Zelorty_Cooldowns()
		RRH_updateFrames()		 --Update frames from Analysis
	end

	if (rr_rmenabled == 1) and (rr_crenabled == 1) and (rr_isRetSpec == 1) and (rr_multi == 0) then   --Do rotation manager stuff if rotation manager enabled and Custom rotation, and you are speced ret
		RRH_updatepowers() 		 --Update cooldowns, spell availability, and GCD
		RRH_customrotationanalysis() 	 --Determine Spell order by analysis
		RRH_Update_and_display_AW_and_Zelorty_Cooldowns()
		RRH_updateFrames()		 --Update frames from Analysis
	end

	if (rr_rmenabled == 1) and (rr_isRetSpec == 1) and (rr_multi == 1) then   --Do multi target rotation manager stuff if rotation manager enabled and default rotation, and you are speced ret
		RRH_updatepowers() 						 --Update cooldowns, spell availability, and GCD
		RRH_multitargetrotationanalysis()			 --Determine Spell order by analysis
		RRH_Update_and_display_AW_and_Zelorty_Cooldowns()
		RRH_updateFrames()						 --Update frames from Analysis
	end



end

-----------------------------------------
--------Checks to see if you are specced ret or not
function checkspec()  
	
	rrnameTalent, rricon, rrtier, rrcolumn, rr_isRetSpec = GetTalentInfo(3, 20); --Checks to see how many talent points spent in Zealotry, returned to rr_isRetSpec
	
	--If manager is enabled, and you are ret spec, and you are a paladin, then display bars per addon
	if (rr_rmenabled == 1) and (rr_isRetSpec == 1) and (playerclass == "PALADIN" ) then
		AB1frame:Show()
		AB2frame:Show()
		if (rr_monitorcd == 1) then   -- Ability hide frames if disabled
			AWCDframe:Show()
			Zelframe:Show()
		end

		
	end

	--If manager is not enabled, or you are not ret spec, or you are not a paladin, then disable addon
	if (rr_rmenabled ~= 1) or (rr_isRetSpec ~= 1) or (playerclass ~= "PALADIN") then
		AB1frame:Hide()
		AB2frame:Hide()
		AWCDframe:Hide()
		Zelframe:Hide()
		rr_isRetSpec = 0  --Disable addon
	end

	--If player is not a paladin hide the HP bars.
	if (playerclass ~= "PALADIN") then		
		HPframe:Hide()
	end



end


---------------------------------------------
----Cooldown frames

function RRH_Update_and_display_AW_and_Zelorty_Cooldowns()

	if (rr_monitorcd == 1) then
	--Get duration of Zealotry
	--if rr_zel ~= nil then
		local start, duration, enabled = GetSpellCooldown(rr_zel);		
		if start ~= 0 then 
			rr_zelcd = (start + duration - GetTime()) - gcd
			rr_zelcd = floor(rr_zelcd)    --Drop Decimals
		else
			rr_zelcd = 0
		end
	
	--end

	--Get duration of Avenging Wrath
		start, duration, enabled = GetSpellCooldown(rr_spellnameAW);
		if start ~= 0 then 
			rr_awcd = (start + duration - GetTime()) 
			rr_awcd = floor(rr_awcd)    --Drop Decimals
		else
			rr_awcd = 0
		end



	---Set text overlays on CD buttons
	
	if (rr_awcd <= 0) then
		AWCDtext:SetText("|cFF00FF00" .. rr_awcd) --green if 0
	else
		AWCDtext:SetText("|cffff0000" .. rr_awcd)	--red if not
	end	

	if (rr_zelcd <= 0) then
		Zeltext:SetText("|cFF00FF00" .. rr_zelcd) --green if 0
	else
		Zeltext:SetText("|cffff0000" .. rr_zelcd)	--red if not
	end	




 	
	end




end
-----------------------------------------------
---RESIZE FRAMES, PASSED AS A PARAMETER, 1.0 is normal size
function RRH_scale(scalesz)
		HPframe:SetScale(scalesz)
		AB1frame:SetScale(scalesz)
		AB2frame:SetScale(scalesz * 0.88)
		AWCDframe:SetScale(scalesz)
		Zelframe:SetScale(scalesz)
		HPframe:SetPoint("CENTER", "UIParent", "CENTER", 0, 0);
end





-----Set HP Frame Texture-----------------------

function RRH_HPSetFrameTexture()

	if (rr_hptexture == 1) then
		empty = "Interface\\AddOns\\retrot\\txt\\basic\\empty.tga"
		hpone = "Interface\\AddOns\\retrot\\txt\\basic\\hpone.tga"
		hptwo = "Interface\\AddOns\\retrot\\txt\\basic\\hptwo.tga"
		hpthree = "Interface\\AddOns\\retrot\\txt\\basic\\pthree.tga"
	else
		empty = "Interface\\AddOns\\retrot\\txt\\links\\empty.tga"
		hpone = "Interface\\AddOns\\retrot\\txt\\links\\hpone.tga"
		hptwo = "Interface\\AddOns\\retrot\\txt\\links\\hptwo.tga"
		hpthree = "Interface\\AddOns\\retrot\\txt\\links\\pthree.tga"
	end		

end




-----------------------------------------------
--Update/determine cooldowns, spell availability, holypower stack, and GCD
function RRH_updatepowers()


	--art of war detect.
	if UnitBuff("player", rr_AoW) == nil then
		aow_usable = 0
	else
		aow_usable = 1
	end

	--Hand of light detect.
	if UnitBuff("player", rr_spellnameHOL) == nil then
		hol_proc = 0	 --no Hol Proc
		rr_holtime = 0 	 --duration left in HoL buff.
	else
		_, _, _, _, _, rr_duration, rr_expirationTime = UnitBuff("player", rr_spellnameHOL) 
		rr_holtime = (rr_expirationTime - GetTime())  --duration left in HoL buff.
		hol_proc = 1
	end


	--check if a spell is usable (how), returns "1" into rr_usable if so.
	how_usable, rr_mana = IsUsableSpell(rr_spellnameHOW)

	--Get time left in GCD  (cooldown on any spell without a cooldown) , changed from Cleanse
	local start, duration, enabled = GetSpellCooldown(20154)   --Seal of Righteousness
	if start ~= 0 then 
		gcd = (start + duration - GetTime())
	else
		gcd = 0
	end

	
	--Calculate what GCD is when including haste. Until this is complete fullgcd will be set to 1.5, when complete it will hold GCD if hasted.
	--local mainSpeed, offSpeed = UnitAttackSpeed("unit");
	--rr_wepspd
	--local rr_hasted = (mainSpeed / rr_wepspd)
	--print (rr_hasted)
	--fullgcd = 1.5
	



	--Get duration of Avenging Wrath
		start, duration, enabled = GetSpellCooldown(rr_spellnameAW);
		if start ~= 0 then 
			rr_awcd = (start + duration - GetTime())
			rr_awcd = ceil(rr_awcd)    --Drop Decimals
		else
			rr_awcd = 0
		end
	
	--Get duration of Inquisition
	if rr_inq ~= nil then
		if UnitBuff("player", rr_inq) == nil then
			inqtime=0
		else
			local bname, brank, btexture, bbuff, bdebuff, bcount, bexpiration, bbuffCount, bdebuffCount, bborder, bcooldown, bstartCooldownTime, bdebuffType, bdebuffColor, bisMine, bisStealable, bbuttonStealable = UnitBuff("player", rr_inq)
			inqtime = bexpiration - GetTime()
		end
	end


	--Get cooldowns on Exorcism Crusader Strike Judgment of Justice Holy Wrath Hammer of Wrath
	--Get Spell durations 

	start, duration, enabled = GetSpellCooldown(rr_spellnameEXO)
	if start ~= 0 then 
		exocd = (start + duration - GetTime())
	else
		exocd = 0
	end

	start, duration, enabled = GetSpellCooldown(rr_spellnameCS)
	if start ~= 0 then 
		cscd = (start + duration - GetTime())
	else
		cscd = 0
	end


	--Judgement CD
	--Wotlk CD calculation
	if (wcataclysm ~= 1) then
		start, duration, enabled = GetSpellCooldown("Judgement of Justice")
		if start ~= 0 then 
			jcd = (start + duration - GetTime())
		else
			jcd = 0
		end
	end

	--Cata CD calculation
	if (wcataclysm == 1) then
			start, duration, enabled = GetSpellCooldown(rr_spellnameJ)
		if start ~= 0 then 
			jcd = (start + duration - GetTime())
		else
			jcd = 0
		end
	end



	start, duration, enabled = GetSpellCooldown(rr_spellnameHOW)
	if start ~= 0 then 
		howcd = (start + duration - GetTime())
	else
		howcd = 0
	end

	start, duration, enabled = GetSpellCooldown(rr_spellnameHW)
	if start ~= 0 then 
		hwcd = (start + duration - GetTime())
	else
		hwcd = 0
	end


end


-----------------------------------------------
--Analyizes current cooldowns, holy power, and buff timers to order attacks
--HArd Coded rotation setup
function RRH_rotationanalysis()


-- Rotation set to in order of highest to lowest: Inq3 , TV3, CS, Exo, Judge, HoW, HW

----ROTATION FOR FIRST ABILITY
if  ((hol_proc == 1 ) or (holypow > 2)) and (inqtime <= rr_inqclip) and (rr_inq ~= nil) and (playerlevel > 80) and (rr_inqenabled == 1) then 
	AB1name = "INQ"

--Special case for CS to be before TV with HoL Proc
elseif (cscd <= (gcd + 0.1)) and (rr_holtime > (2+gcd)) and (holypow < 3)  then
	AB1name = "CS"

elseif (holypow > 2) or (hol_proc == 1) then
	AB1name = "TV"

elseif (cscd <= (gcd + abdelta + rr_cs_gcd_delay)) then
	AB1name = "CS"

elseif (howcd <= (gcd+abdelta)) and (how_usable == 1) then
	AB1name = "HOW"

elseif (exocd <= (gcd+abdelta)) and (aow_usable == 1) then
	AB1name = "EXO"

elseif jcd <= (gcd+abdelta) then
	AB1name = "J"

elseif hwcd <= (gcd+abdelta) then
	AB1name = "HW"

else
	AB1name = "nil"

end




-------ROTATION FOR SECOND ABILITY
--Accounts for the first button

--Either 3HP OR  HoL proc
if (((hol_proc == 1 ) or (holypow > 2)) or ((AB1name == "CS") and (holypow >= 2))) and ((inqtime - gcd)  <= rr_inqclip) and (AB1name ~= "INQ") and (AB1name ~= "TV") and (rr_inq ~= nil) and (playerlevel > 80) and (rr_inqenabled == 1) then 
	AB2name = "INQ"

--Both 3 HP AND HoL proc
elseif (((hol_proc == 1 ) and (holypow >2))) and ((inqtime - gcd)  <= rr_inqclip) and (AB1name ~= "INQ") and (rr_inq ~= nil) and (playerlevel > 80) then 
	AB2name = "INQ"

--Special case for CS to be before TV with HoL Proc
elseif ((cscd)  <= (gcd + fullgcd + 0.1)) and (AB1name ~= "CS") and (rr_holtime > (2+gcd + fullgcd )) and (holypow < 3) then
	AB2name = "CS"

--Both 3 HP AND HoL proc
elseif ((hol_proc == 1 ) and (holypow > 2)) and ((AB1name == "TV") or (AB1name == "INQ"))  then
	AB2name = "TV"

--Either 3HP OR  HoL proc
elseif (((hol_proc == 1 ) or (holypow > 2)) or ((AB1name == "CS") and (holypow >= 2))) and (AB1name ~= "INQ") and (AB1name ~= "TV") then 
	AB2name = "TV"

elseif ((cscd)  <= (gcd + fullgcd + rr_cs_gcd_delay)) and (AB1name ~= "CS") then
	AB2name = "CS"

elseif ((howcd) <= (gcd+fullgcd)) and (how_usable == 1) and (AB1name ~= "HOW") then
	AB2name = "HOW"

elseif ((exocd) <= (gcd+fullgcd)) and (aow_usable == 1) and (AB1name ~= "EXO") then
	AB2name = "EXO"

elseif (jcd) <= (gcd+fullgcd) and (AB1name ~= "J") then
	AB2name = "J"


elseif (hwcd) <= (gcd+fullgcd) and (AB1name ~= "HW") then
	AB2name = "HW"

else
	AB2name = "nil"

end




end


-----------------------------------------------

--UPDATES HOLY POWER FRAMES
function RRH_updateHolyPowerFrames()

	--Get amount of holy power if in cataclysm
	if (playerclass == "PALADIN")  then
		holypow = UnitPower("player", 9)
	end


	--Update Holy power frame
	if holypow > 2 then
		HPtexture:SetTexture(hpthree)

	elseif holypow == 1 then
		HPtexture:SetTexture(hpone)

	elseif holypow == 2 then
		HPtexture:SetTexture(hptwo)

	else
		HPtexture:SetTexture(empty)
	end



end







--FUNCTION TO UPDATE ABILITY FRAMES AFTER PROCESSING
function RRH_updateFrames()




	--Test to see if display item has changed, it not dont redo textures
	if (lastAB1 ~= AB1name) then 

		--Update Ability 1 Framse
		if AB1name == "CS" then
			AB1texture:SetTexture(GetSpellTexture(rr_spellnameCS))

		elseif AB1name == "EXO" then
			AB1texture:SetTexture(GetSpellTexture(rr_spellnameEXO))
	
		--elseif (AB1name == "J") and (wcataclysm ~= 1) then
		--	AB1texture:SetTexture(GetSpellTexture("Judgement of Light"))
		
		elseif (AB1name == "J") and (wcataclysm == 1) then
			AB1texture:SetTexture(GetSpellTexture(rr_spellnameJ))
		
		elseif AB1name == "HOW" then
			AB1texture:SetTexture(GetSpellTexture(rr_spellnameHOW))
		
		elseif AB1name == "HW" then
			AB1texture:SetTexture(GetSpellTexture(rr_spellnameHW))
		
		elseif AB1name == "INQ" then
			AB1texture:SetTexture(GetSpellTexture(rr_inq))
		
		elseif AB1name == "TV" then
			AB1texture:SetTexture(GetSpellTexture(rr_spellnameTV))

		elseif AB1name == "DS" then
			AB1texture:SetTexture(GetSpellTexture(rr_spellnameDS))
		
		elseif AB1name == "nil" then
			AB1texture:SetTexture(GetSpellTexture("Intercept"))  --Non existing for spec blanks out frame
		end

	
		lastAB1 = AB1name  --Since ability changed update recently used

	end


	--Test to see if display item has changed, it not dont redo textures
	if (lastAB2 ~= AB2name) then 

		--Update Ability 2 Framse
		if AB2name == "CS" then
			AB2texture:SetTexture(GetSpellTexture(rr_spellnameCS))
	
		elseif AB2name == "EXO" then
			AB2texture:SetTexture(GetSpellTexture(rr_spellnameEXO))
		
		--elseif (AB2name == "J") and (wcataclysm ~=1) then
		--	AB2texture:SetTexture(GetSpellTexture("Judgement of Light"))		

		elseif (AB2name == "J") and (wcataclysm == 1) then
			AB2texture:SetTexture(GetSpellTexture(rr_spellnameJ))
		
		elseif AB2name == "HOW" then
			AB2texture:SetTexture(GetSpellTexture(rr_spellnameHOW))	

		elseif AB2name == "HW" then
			AB2texture:SetTexture(GetSpellTexture(rr_spellnameHW))
	
		elseif AB2name == "INQ" then
			AB2texture:SetTexture(GetSpellTexture(rr_inq))
	
		elseif AB2name == "TV" then
			AB2texture:SetTexture(GetSpellTexture(rr_spellnameTV))

		elseif AB2name == "DS" then
			AB2texture:SetTexture(GetSpellTexture(rr_spellnameDS))

		elseif AB2name == "nil" then
			AB2texture:SetTexture(GetSpellTexture("Intercept"))  --Non existing for spec blanks out frame
		end

		lastAB2 = AB2name  --Since ability changed update recently used

	end

		---Set Text overlay on buttons
	if (AB1name ~= "nil") then
		AB1text:SetText("|cFF00FF00" .. AB1name)
	else
		AB1text:SetText("")
	end

	if (AB2name ~= "nil") then
		AB2text:SetText("|cFF00FF00" .. AB2name)
	else
		AB2text:SetText("")
	end



end





-----------------------------------------------

function RRH_OnEvent(self, event, ...)


		if (event == "ADDON_LOADED") then

		--PLayerclass variable
		_, playerclass = UnitClass("player")


		RRH_scale(rr_scale) --set frame scales
		HPframe:SetPoint("BOTTOMLEFT", rr_x, rr_y);  --restore frame position


		--get addon name
		local aname = select(1, ...);

		if (aname == "retrot") then --do this if the addon is retrot

			--Check spec to make sure you are ret
			checkspec() 	


			---reload textures to prevent non-display errors
			AWCDtexture:SetTexture(GetSpellTexture(rr_spellnameAW))
			Zeltexture:SetTexture(GetSpellTexture(rr_zel))

			retconfigForm:Hide() -- hide config form

			--Load currnet configuration into config frame
			EditBox1:SetNumber(rr_inqclip);      
			EditBox2:SetNumber(rr_scale);        
			EditBox3:SetNumber(rr_jmana); 
			EditBox4:SetNumber(rr_wepspd); 
			EditBox5:SetNumber(rr_cs_gcd_delay); 

			rrhab1box:SetText(string.upper(rr_cab1));
			rrhab2box:SetText(string.upper(rr_cab2));
			rrhab3box:SetText(string.upper(rr_cab3));
			rrhab4box:SetText(string.upper(rr_cab4));
			rrhab5box:SetText(string.upper(rr_cab5));
     	
			playerlevel = UnitLevel("player"); --Get player level for inquisition check
			Check2:SetChecked(rr_inqenabled);	--Inquisition enabled in rotation?
			Check1:SetChecked(rr_rmenabled); --Is the rotation manager enabled?
			Check3:SetChecked(rr_crenabled); --Is the custom rotation enabled?
			Check4:SetChecked(rr_hptexture); --Set display
			Check5:SetChecked(rr_monitorcd); --Set visibility of AW/Zel Frames
			Check6:SetChecked(rr_autohide); --Auto hide option

			RRH_HPSetFrameTexture(); 		--Set HP Frame Tecture

			--Code to hide/show Ability frames depending on rotation manager being enabled or not.
			if (rr_rmenabled ~= 1) then   -- Ability hide frames if disabled
				AB1frame:Hide()
				AB2frame:Hide()
			else
				AB1frame:Show()
				AB2frame:Show()
			end


			--Code to hide/show Cooldown frames if Tracking if enabled.
			if (rr_monitorcd ~= 1) then   -- Ability hide frames if disabled
				AWCDframe:Hide()
				Zelframe:Hide()
			else
				AWCDframe:Show()
				Zelframe:Show()
			end



			print(rrh_version .. " By Cannadrys - Mugthol/US")
			print("To move addon, hold down control and drag any of the holy power indicators")
			end
		end







		if (event == "PLAYER_TALENT_UPDATE") then
		
			--Check spec to make sure you are ret
			checkspec() 

			---reload textures to prevent non-display errors
			AWCDtexture:SetTexture(GetSpellTexture(rr_spellnameAW))
			Zeltexture:SetTexture(GetSpellTexture(rr_zel))

		end



		--CALLED WHEN PLAYER LEAVES COMBAT
		-- use to hide frames if enabled
		if (event == "PLAYER_REGEN_ENABLED") then
			if rr_autohide == 1 then
				AB1frame:Hide()
				AB2frame:Hide()
				AWCDframe:Hide()
				Zelframe:Hide()
			end
		end


		--CALLED WHEN PLAYER ENTERS COMBAT
		--used to autoshow frames
		if (event == "PLAYER_REGEN_DISABLED") then
			if (rr_autohide == 1) and (rr_isRetSpec == 1) then
				if rr_rmenabled == 1 then 
					AB1frame:Show()
					AB2frame:Show()
				end

				if rr_monitorcd == 1 then
					AWCDframe:Show()
					Zelframe:Show()
				end
			end	

		end

		 

end



-----------------------------------------------


function RRH_SlashCommandHandler(msg)

	msg = string.lower(msg)

	if (msg == "") then
		print("RRH USAGE: Control click one of the HOLY POWER DOT INDICATORS to drag to a different part of your screen.")
		print("/RRH config  -  Opens the configuration screen")
		print("/RRH version - Displays addon version")
		print("/RRH reset - resets addon")
	end

	if (msg == "reset") then
		
	end	

	
	if (msg == "1") then	
		HPtexture:SetTexture(hpone)
		AB1texture:SetTexture(GetSpellTexture("Divine Storm"))
	end	

	if (msg == "2") then		
		HPtexture:SetTexture(hptwo)
		AB1texture:SetTexture(GetSpellTexture("Cleanse"))
	end

	if (msg == "3") then	
		HPtexture:SetTexture(hpthree)
		AB1texture:SetTexture(GetSpellTexture(rr_spellnameEXO))
	end

	if (msg == "4") then		

	end

	if (msg == "5") then		

	end

	if (msg == "hide") then

		retconfigForm:Hide()

	end	

	if (msg == "config") then
		retconfigForm:Show()
	end	

	if (msg == "setup") then
		retconfigForm:Show()
	end	


	if (msg == "version") then
		print(rrh_version)
	end	



end


------------------------------------
---OK button press in config screen
function  RRH_configBuffonPress()
	
	--Hide fram after accepting changes
	retconfigForm:Hide()

	--Save configuration
	rr_inqclip = EditBox1:GetNumber();      --Inquisition Clipping in seconds, 0 = disabled
	rr_scale = EditBox2:GetNumber();        --Frame scaling
	rr_jmana = EditBox3:GetNumber();        --Priotitize Judgement if JoTW not active 1=yes 0=no
	rr_wepspd = EditBox4:GetNumber();		--Get Weapon Speed
	rr_cs_gcd_delay = EditBox5:GetNumber();

	rr_cab1 = string.upper(rrhab1box:GetText())
	rr_cab2 = string.upper(rrhab2box:GetText())
	rr_cab3 = string.upper(rrhab3box:GetText())
	rr_cab4 = string.upper(rrhab4box:GetText())
	rr_cab5 = string.upper(rrhab5box:GetText())


	RRH_scale(rr_scale)			 --set frame scales


	if (Check3:GetChecked() == 1) then
		rr_crenabled = 1	--Custom rotation eabled
	else
		rr_crenabled = 0    --Custom rotation disabled
	end


	if (Check2:GetChecked() == 1) then
		rr_inqenabled = 1	--Inquisition enabled
	else
		rr_inqenabled = 0    --Inquisition disabled
	end


	if (Check1:GetChecked() == 1) then
		rr_rmenabled = 1	--Rotation Manager enabled
	else
		rr_rmenabled = 0    --Rotation Manager disabled
	end

	if (Check4:GetChecked() == 1) then
		rr_hptexture = 1	--basic HP bar texture
	else
		rr_hptexture = 0    --links texture
	end

	if (Check5:GetChecked() == 1) then
		rr_monitorcd = 1	--Monitor and display CDs
	else
		rr_monitorcd = 0    --Do not monitor/display AW/Zel CDs
	end


	if (Check6:GetChecked() == 1) then
		rr_autohide = 1	--Auto hide not in combat
	else
		rr_autohide = 0    --Do not auto hide in combat

		if rr_rmenabled == 1 then 
			AB1frame:Show()
			AB2frame:Show()
		end

		if rr_monitorcd == 1 then
			AWCDframe:Show()
			Zelframe:Show()
		end
	end



	--Is the rotation manager enabled?
	Check1:SetChecked(rr_rmenabled); 

		if (rr_rmenabled ~= 1) then   -- Ability hide frames if disabled
			AB1frame:Hide()
			AB2frame:Hide()
		else
			AB1frame:Show()
			AB2frame:Show()
		end

	
	--Code to hide/show Cooldown Tracking if enabled.
	Check5:SetChecked(rr_monitorcd); 

		if (rr_monitorcd ~= 1) then   -- Ability hide frames if disabled
			AWCDframe:Hide()
			Zelframe:Hide()
		else
			AWCDframe:Show()
			Zelframe:Show()
		end

	RRH_HPSetFrameTexture() --Set HP frame texture

end
-----------------------------------------------

function RRH_OnLoad()

	RRH:RegisterEvent("PLAYER_REGEN_DISABLED");
	RRH:RegisterEvent("PLAYER_REGEN_ENABLED");
	RRH:RegisterEvent("PLAYER_TALENT_UPDATE");
	--RRH:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	RRH:RegisterEvent("ADDON_LOADED");
  	SLASH_RRH1 = "/rrhrrh";
  	SLASH_RRH2 = "/RRH";
 	 SlashCmdList["RRH"] = function(msg)
		RRH_SlashCommandHandler(msg);
	end

	

end











































-----------------------------------------------------------
---------CUSTOM ROTATION AREA------------------------------
-----------------------------------------------------------



--Analyizes current cooldowns, holy power, and buff timers to order attacks
--Custom Coded rotation, base crame to individual calls
function RRH_customrotationanalysis()

	AB1name = "nil"  --set variable NIL
	AB2name = "nil"

	--PROCESS FIRST ABILITY
	--Process Fixed entries first.
	if  ((hol_proc == 1 ) or (holypow > 2)) and (inqtime <= rr_inqclip) and (rr_inq ~= nil) and (playerlevel > 80) and (rr_inqenabled == 1) then 
		AB1name = "INQ"
	elseif (holypow > 2) or (hol_proc == 1) then
		AB1name = "TV"
	end	


	if AB1name == "nil" then		--Run check on first ability if no 
		RRH_customcheckprimary(rr_cab1) 
	end
	if AB1name == "nil" then		--Run check on 2nd ability if no 
		RRH_customcheckprimary(rr_cab2) 
	end
	if AB1name == "nil" then		--Run check on 3rd ability if no 
		RRH_customcheckprimary(rr_cab3) 
	end
	if AB1name == "nil" then		--Run check on 4th ability if no 
		RRH_customcheckprimary(rr_cab4) 
	end
	if AB1name == "nil" then		--Run check on 5th ability if no 
		RRH_customcheckprimary(rr_cab5) 
	end

	
	------PROCESS SECOND ABILITY, HAD FIXED FIRST
	--Either 3HP OR  HoL proc
	if (((hol_proc == 1 ) or (holypow > 2)) or ((AB1name == "CS") and (holypow >= 2))) and ((inqtime - gcd)  <= rr_inqclip) and (AB1name ~= "INQ") and (AB1name ~= "TV") and (rr_inq ~= nil) and (playerlevel > 80) and (rr_inqenabled == 1) then 
		AB2name = "INQ"

	--Both 3 HP AND HoL proc
	elseif (((hol_proc == 1 ) and (holypow >2))) and ((inqtime - gcd)  <= rr_inqclip) and (AB1name ~= "INQ") and (rr_inq ~= nil) and (playerlevel > 80) then 
		AB2name = "INQ"

	--Both 3 HP AND HoL proc
	elseif ((hol_proc == 1 ) and (holypow > 2)) and ((AB1name == "TV") or (AB1name == "INQ"))  then
		AB2name = "TV"
	
	--Either 3HP OR  HoL proc
	elseif (((hol_proc == 1 ) or (holypow > 2)) or ((AB1name == "CS") and (holypow >= 2))) and (AB1name ~= "INQ") and (AB1name ~= "TV") then 
		B2name = "TV"
	end


	if AB2name == "nil" then		--Run check on first ability if no 
		RRH_customchecksecondary(rr_cab1) 
	end
	if AB2name == "nil" then		--Run check on 2 ability if no 
		RRH_customchecksecondary(rr_cab2) 
	end
	if AB2name == "nil" then		--Run check on 3 ability if no 
		RRH_customchecksecondary(rr_cab3) 
	end
	if AB2name == "nil" then		--Run check on 4 ability if no 
		RRH_customchecksecondary(rr_cab4) 
	end
	if AB2name == "nil" then		--Run check on 5 ability if no 
		RRH_customchecksecondary(rr_cab5) 
	end

end



---
---
function RRH_customcheckprimary(currentcheck)



if (cscd <= (gcd + abdelta + rr_cs_gcd_delay)) and (currentcheck == "CS") then
	AB1name = "CS"

elseif (howcd <= (gcd+abdelta)) and (how_usable == 1) and (currentcheck == "HOW") then
	AB1name = "HOW"

elseif (exocd <= (gcd+abdelta)) and (aow_usable == 1) and (currentcheck == "EXO") then
	AB1name = "EXO"

elseif jcd <= (gcd+abdelta) and (currentcheck == "J") then
	AB1name = "J"

elseif hwcd <= (gcd+abdelta) and (currentcheck == "HW") then
	AB1name = "HW"

end
end



function RRH_customchecksecondary(currentcheck)

-------ROTATION FOR SECOND ABILITY
--Accounts for the first button


if ((cscd)  <= (gcd + fullgcd + rr_cs_gcd_delay)) and (AB1name ~= "CS") and (currentcheck == "CS") then
	AB2name = "CS"

elseif ((howcd) <= (gcd+fullgcd)) and (how_usable == 1) and (AB1name ~= "HOW") and (currentcheck == "HOW") then
	AB2name = "HOW"

elseif ((exocd) <= (gcd+fullgcd)) and (aow_usable == 1) and (AB1name ~= "EXO") and (currentcheck == "EXO") then
	AB2name = "EXO"

elseif (jcd) <= (gcd+fullgcd) and (AB1name ~= "J") and (currentcheck == "J") then
	AB2name = "J"

elseif (hwcd) <= (gcd+fullgcd) and (AB1name ~= "HW") and (currentcheck == "HW") then
	AB2name = "HW"


end

end




































-----------------------------------------------
----------------MULTI TARGET ROTATION----------
--Analyizes current cooldowns, holy power, and buff timers to order attacks
--HArd Coded rotation setup
function RRH_multitargetrotationanalysis()


----ROTATION FOR FIRST ABILITY
--Special case for CS to be before TV with HoL Proc
if (cscd <= (gcd + 0.1)) and (rr_holtime > (2+gcd)) and (holypow < 3)  then
	AB1name = "CS"

elseif (holypow > 2) or (hol_proc == 1) then
	AB1name = "DS"

elseif (cscd <= (gcd + abdelta + rr_cs_gcd_delay)) then
	AB1name = "CS"

elseif (howcd <= (gcd+abdelta)) and (how_usable == 1) then
	AB1name = "HOW"

elseif (exocd <= (gcd+abdelta)) and (aow_usable == 1) then
	AB1name = "EXO"

elseif jcd <= (gcd+abdelta) then
	AB1name = "J"

elseif hwcd <= (gcd+abdelta) then
	AB1name = "HW"

else
	AB1name = "nil"

end




-------ROTATION FOR SECOND ABILITY
--Accounts for the first button


--Special case for CS to be before TV with HoL Proc
if ((cscd)  <= (gcd + fullgcd + 0.1)) and (AB1name ~= "CS") and (rr_holtime > (2+gcd + fullgcd )) and (holypow < 3) then
	AB2name = "CS"

--Both 3 HP AND HoL proc
elseif ((hol_proc == 1 ) and (holypow > 2)) and ((AB1name == "DS") or (AB1name == "INQ"))  then
	AB2name = "DS"

--Either 3HP OR  HoL proc
elseif (((hol_proc == 1 ) or (holypow > 2)) or ((AB1name == "CS") and (holypow >= 2))) and (AB1name ~= "INQ") and (AB1name ~= "DS") then 
	AB2name = "DS"

elseif ((cscd)  <= (gcd + fullgcd + rr_cs_gcd_delay)) and (AB1name ~= "CS") then
	AB2name = "CS"

elseif ((howcd) <= (gcd+fullgcd)) and (how_usable == 1) and (AB1name ~= "HOW") then
	AB2name = "HOW"

elseif ((exocd) <= (gcd+fullgcd)) and (aow_usable == 1) and (AB1name ~= "EXO") then
	AB2name = "EXO"

elseif (jcd) <= (gcd+fullgcd) and (AB1name ~= "J") then
	AB2name = "J"


elseif (hwcd) <= (gcd+fullgcd) and (AB1name ~= "HW") then
	AB2name = "HW"

else
	AB2name = "nil"

end




end